defmodule ExFinancialModelingPrep.Struct.BalanceSheetStatement do
  @moduledoc """
  Struct: BalanceSheetStatement
  """
  use TypedStruct

  typedstruct do
    field(:deferred_revenue_non_current, float())
    field(:inventory, integer())
    field(:other_current_liabilities, integer())
    field(:property_plant_equipment_net, integer())
    field(:tax_payables, float())
    field(:accepted_date, DateTime.t())
    field(:goodwill, float())
    field(:other_liabilities, float())
    field(:goodwill_and_intangible_assets, float())
    field(:total_non_current_assets, integer())
    field(:period, String.t())
    field(:total_equity, integer())
    field(:total_liabilities, integer())
    field(:long_term_debt, integer())
    field(:account_payables, integer())
    field(:total_liabilities_and_total_equity, integer())
    field(:net_receivables, integer())
    field(:cash_and_cash_equivalents, integer())
    field(:total_liabilities_and_stockholders_equity, integer())
    field(:short_term_debt, integer())
    field(:reported_currency, String.t())
    field(:total_assets, integer())
    field(:other_current_assets, integer())
    field(:other_non_current_liabilities, integer())
    field(:othertotal_stockholders_equity, float())
    field(:symbol, String.t())
    field(:total_current_liabilities, integer())
    field(:final_link, String.t())
    field(:capital_lease_obligations, float())
    field(:tax_assets, float())
    field(:filling_date, Date.t())
    field(:common_stock, integer())
    field(:retained_earnings, integer())
    field(:net_debt, integer())
    field(:long_term_investments, integer())
    field(:total_debt, integer())
    field(:minority_interest, integer())
    field(:total_stockholders_equity, integer())
    field(:cik, String.t())
    field(:link, String.t())
    field(:deferred_revenue, integer())
    field(:calendar_year, String.t())
    field(:other_assets, float())
    field(:intangible_assets, float())
    field(:date, Date.t())
    field(:deferred_tax_liabilities_non_current, float())
    field(:preferred_stock, integer())
    field(:short_term_investments, integer())
    field(:total_investments, integer())
    field(:cash_and_short_term_investments, integer())
    field(:other_non_current_assets, integer())
    field(:total_non_current_liabilities, integer())
    field(:total_current_assets, integer())
    field(:accumulated_other_comprehensive_income_loss, integer())
  end
end
